{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Reportes{% endblock %}

{% block extra_head %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">
{% endblock extra_head %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
		<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
		<li class="breadcrumb-item"><a href="{% url 'customer-list' %}">Clientes</a></li>
    <li class="breadcrumb-item active">Reportes estado de Planes</li>
	</ol>
	<!-- end breadcrumb -->

	<!-- begin page-header -->
	<h1 class="page-header">Reportes estado <small>Planes</small></h1>
	<!-- end page-header -->

		<!-- begin row -->
		<div class="row">
				<!-- begin col-12 -->
				<div class="col-xl-12 ui-sortable">
					<!-- begin panel -->
					<div class="panel panel-inverse" data-sortable-id="ui-general-1">
						<!-- begin panel-heading -->
						<div class="panel-heading ui-sortable-handle">
							<h4 class="panel-title">Reportes estado de Planes</h4>
							<div class="panel-heading-btn">
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
							</div>
						</div>
						<!-- end panel-heading -->
						<!-- begin panel-body -->
						<div class="panel-body">
							<div id="service-status-app">
								<div class="row mb-3">
									<div class="col-md-6">
										<h5 class="text-muted">Filtros:</h5>
										<p>
										<label>Desde:</label>
										<input type="date" v-model="initiald">
										</p>
										
										<p>
											<label>Hasta:</label>
											<input type="date" v-model="finald">
										</p>
									
										<p>
										<label>Estado:</label>
										<v-select v-model="selectedStatus" :options="statusOptions"></v-select>
										</p>
									
										<p>
										<label>Vendedor:</label>
										<v-select v-model="selectedSeller" :options="sellerOptions"></v-select>
										</p>
									
										<p>
										<label>Técnico:</label>
										<v-select v-model="selectedTechnician" :options="technicianOptions"></v-select>
										</p>
									
										<p>
										<label>Nodo:</label>
										<v-select v-model="selectedNode" :options="nodeOptions"></v-select>
										</p>
									</div>
									<div class="col-md-6">
											{% verbatim %}
										  <h5 class="text-muted">{{ message }}</h5>
										  <table class="table table-bordered">
									  
										  <tr v-for="(item, key, index) in snapshots">
											<td>{{ key }}</td>
											<td><button type="button" class="btn btn-lg" data-toggle="popover" title="Detalle servicios" :data-content="item.services">{{ item.count }}</button></td>
										  </tr>
										  </table>
											{% endverbatim %}
									</div>

								</div>
							</div>
						</div>
						<!-- end panel-body -->
						</div>
						<!-- end panel -->
						</div>
						</div>
						<!-- end row -->
						
						<!-- begin scroll to top btn -->
						<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
						<!-- end scroll to top btn -->
						
						{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("reports_menu").classList.add("active");
    //active submenu item
    document.getElementById("planreport_item").classList.add("active");
</script>

<script src="{% static 'js/vue' %}"></script>
    <script src="{% static 'js/vue-resource' %}"></script>
    <script src="{% static 'js/vue-select' %}"></script>
    <script src="{% static 'js/lodash.min.js' %}"></script>

<script>
    get = function(obj, key) {
	return key.split(".").reduce(function(o, x) {
	    return (typeof o == "undefined" || o === null) ? o : o[x];
	}, obj);
    }

  Vue.component('v-select', VueSelect.VueSelect);

  // Register a global custom directive called v-focus
  Vue.directive('focus', {
  // When the bound element is inserted into the DOM...
  inserted: function (el) {
  // Focus the element
  el.focus()
    
  }
  
  })

  var service_status_app = new Vue({
      el: '#service-status-app',
      data: {
          message: null,
	  initiald: "{{ first_of_month }}",
	  finald: "{{ last_of_month }}",
	  snapshots: {},
	  nodeOptions: [{value: null, label: "Todos"},{% for node in nodes %}{value: {{ node.pk }}, label: "{{ node }}"},{% endfor %}],
	  selectedNode: {value: null, label: "Todos"},
	  sellerOptions: [{value: null, label: "Todos"},{% for seller in sellers %}{value: {{ seller.pk }}, label: "{{ seller }}"},{% endfor %}],
	  selectedSeller: {value: null, label: "Todos"},
	  technicianOptions: [{value: null, label: "Todos"},{% for technician in technicians %}{value: {{ technician.pk }}, label: "{{ technician }}"},{% endfor %}],
	  selectedTechnician: {value: null, label: "Todos"},
	  statusOptions: [{value: null, label: "Todos"},{% for status in statuses %}{value: {{ status.code }}, label: "{{ status.name }}"},{% endfor %}],
	  selectedStatus: {value: null, label: "Todos"},
      },
      watch: {
	  initiald: function(newInitialD) {
	      if (newInitialD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  finald: function(newFinalD) {
	      if (newFinalD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedStatus: function(newStatus) {
	      if (newStatus) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedNode: function(newNode) {
	      if (newNode) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedSeller: function(newSeller) {
	      if (newSeller) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedTechnician: function(newTechnician) {
	      if (newTechnician) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  }
      },
      mounted: function () {
	  this.refreshData();
      },
      methods: {
	  refreshData: _.debounce(
	      function() {
		  this.$http.get('/customers/table-ajax/'+'?'+'initiald='+this.initiald+'&finald='+this.finald+'&status='+get(this.selectedStatus, 'value')+'&seller='+get(this.selectedSeller, 'value')+'&technician='+get(this.selectedTechnician, 'value')+'&node='+get(this.selectedNode, 'value')).then(response => {
		      var unordered = response.body.snapshot_data;
		      var ordered = {};
		      Object.keys(unordered).sort().forEach(function(key) {
			  ordered[key] = unordered[key];
		      });
		      this.snapshots = ordered;
		      this.message = null;
		  });
	      },
	      300
	  )
      }
  })


    // fugly
    $(function (){
    setInterval(function (){
    $('[data-toggle="popover"]').popover();
    }, 500);
    });

</script>

{% endblock %}
